// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//
// Copyright (C) 1993-1996  Microsoft Corporation.  All Rights Reserved.
//
//  MODULE:   main.c
//
//  PURPOSE:  This program is the command line client for the EjectService service
//
//  USAGE:	Eject [computer name] <driveletter>:
//
//  FUNCTIONS:
//    main(int argc, char **argv);
//
//  COMMENTS:
//
// This file was created on 1/21/99 by Max Feingold (maf6@cornell.edu) based on 
// the file 'client.c' in Microsoft's "Service" sample from the Visual Studio MSDN libraries.
//
// Neither Microsoft nor Max are responsible for the misuse of this file or its corresponding
// executable.  As far as Max is concerned you can do whatever you want with either.  As for Microsoft,
// you'd better ask them.

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void main(int argc, char *argv[])
{
    char    inbuf[80];
    DWORD   bytesRead;
    BOOL    ret, valid;
    char pszPipeName [512], pszDriveName [20];

	printf ("Eject 2.0\n");
	printf ("(c) 1999 Max Attar Feingold\n\n");

	switch (argc) {

	case 2:

		// Eject from localhost
		if (strlen (argv[1]) != 2 || !isalpha (argv[1][0]) || argv[1][1] != ':') {
			valid = FALSE;
		} else {
			valid = TRUE;
			strcpy (pszPipeName, "\\\\.\\pipe\\ejectservice");
			strcpy (pszDriveName, argv[1]);
		}

		break;

	case 3:

		// Eject from remote computer
		if (!isalpha (argv[2][0]) || argv[2][1] != ':') {
			valid = FALSE;
		} else {
			valid = TRUE;
			sprintf (pszPipeName, "\\\\%s\\pipe\\ejectservice", argv[1]);
			strcpy (pszDriveName, argv[2]);
		}

		break;

	default:
		valid = FALSE;
	}

	if (!valid) {
		printf ("Usage:  Eject [computer name] <driveletter>:\n");
		exit (-1);
	}

	// Make call
    ret = CallNamedPipeA (pszPipeName,
                          pszDriveName, sizeof (pszDriveName),
                          inbuf, sizeof (inbuf),
                          &bytesRead, 
						  NMPWAIT_WAIT_FOREVER);

    if (!ret) {
		printf ("The server could not be contacted\n");
/*      printf("CallNamedPipe failed, GetLastError = %d\n", GetLastError());*/
        exit (-1);
    }

    printf("%s", inbuf);
}
